commit d541ba2a54c2521c1cb01bfd6b0013f1563ef2f4
Author: freddy77 <freddy77>
Date:   Tue Aug 25 14:25:35 2009 +0000

    Use MS protocol version (7.1 for mssql2k and 7.2 for mssql2k5)

diff --git a/ChangeLog b/ChangeLog
index d029572..1444d24 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,13 @@
+Tue Aug 25 16:23:49 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* doc/freebcp.txt doc/freetds.conf.5 doc/tds_ssl.html:
+	* doc/userguide.sgml include/sybdb.h include/tds.h src/dblib/bcp.c:
+	* src/dblib/dblib.c src/dblib/unittests/t0022.c src/pool/util.c:
+	* src/server/login.c src/server/server.c src/server/unittest.c:
+	* src/tds/bulk.c src/tds/config.c src/tds/login.c src/tds/mem.c:
+	* src/tds/net.c src/tds/query.c src/tds/tds_checks.c:
+	* src/tds/token.c src/tds/util.c win32/winsetup.c:
+	- Use MS protocol version (7.1 for mssql2k and 7.2 for mssql2k5)
+
 Fri Aug 21 12:10:57 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/data.c src/tds/token.c:
 	- fix variant type for data converted to client encoding
@@ -1786,4 +1796,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2857 2009/08/21 10:11:19 freddy77 Exp $
+$Id: ChangeLog,v 1.2858 2009/08/25 14:25:35 freddy77 Exp $
diff --git a/doc/userguide.sgml b/doc/userguide.sgml
index 1c42309..2c34cab 100644
--- a/doc/userguide.sgml
+++ b/doc/userguide.sgml
@@ -5,8 +5,8 @@
 ]>
 <book>
 	<bookinfo>
-		<date>$Date: 2009/06/06 16:24:11 $</date>
-		<releaseinfo>$Revision: 1.124 $</releaseinfo>
+		<date>$Date: 2009/08/25 14:25:35 $</date>
+		<releaseinfo>$Revision: 1.125 $</releaseinfo>
 		<title><productname>FreeTDS</productname> User Guide</title>
 		<subtitle>A Guide to Installing, Configuring, and Running <productname>FreeTDS</productname></subtitle>
 		<author>
@@ -57,9 +57,9 @@ This guide is here for you, and we hope that you will be here for it, that other
 The version you're reading is:
 			</para> 
   			<simplelist type='vert'>
-<member>$Revision: 1.124 $</>
-<member>$Date: 2009/06/06 16:24:11 $</>
-<member>CVS control number $Id: userguide.sgml,v 1.124 2009/06/06 16:24:11 freddy77 Exp $.</>
+<member>$Revision: 1.125 $</>
+<member>$Date: 2009/08/25 14:25:35 $</>
+<member>CVS control number $Id: userguide.sgml,v 1.125 2009/08/25 14:25:35 freddy77 Exp $.</>
   			</simplelist>
 			</footnote>
 can be found on the <productname>FreeTDS</productname> 
@@ -153,7 +153,7 @@ Introduced for <productname>SQL Server 7.0</productname>.  Includes support for
 			</para>
 			</listitem></varlistentry>
 
-			<varlistentry><term>TDS 8.0
+			<varlistentry><term>TDS 7.1
 			  Microsoft</term>
 			<listitem>
 			<para>
@@ -161,6 +161,14 @@ Introduced for <productname>SQL Server 2000</productname>.  Includes support for
 			</para>
 			</listitem></varlistentry>
 
+			<varlistentry><term>TDS 7.2
+			  Microsoft</term>
+			<listitem>
+			<para>
+Introduced for <productname>SQL Server 2005</productname>.  Includes support for varchar(max), varbinary(max), xml datatypes and MARS.
+			</para>
+			</listitem></varlistentry>
+
 			</variablelist>
 		  </sect1>
 
@@ -172,7 +180,7 @@ Introduced for <productname>SQL Server 2000</productname>.  Includes support for
 In early 1997, the only option for connecting to a Sybase server from Linux or other free systems was an aging Sybase-released version of <productname>OpenClient</productname>.  Unfortunately it had a few problems.  The original release was <symbol>a.out</>-based, although Greg Thain did a great service in converting the library to ELF.  Secondly, it included only the newer <systemitem class="library">ct-lib</systemitem> <acronym>API</>.  The older <systemitem class="library">db-lib</systemitem> <acronym>API</> was missing.
 			</para>
 			<para>
-Brian Bruns, a Sybase DBA and originator of the <productname>FreeTDS</productname> project, had some <systemitem class="library">db-lib</systemitem> programs he wanted to run under Linux, and thus began the <productname>FreeTDS</productname> project. The original work focused on <systemitem class="library">db-lib</systemitem> and version 5.0 of the protocol, but quickly expanded to include a <systemitem class="library">ct-lib</systemitem> compatible layer and <acronym>TDS</> version 4.2.  Later support for <systemitem class="library">ODBC</systemitem> and <acronym>TDS 7.0 and 8.0</> was added. Craig Spannring wrote a Java  <acronym>JDBC</> driver which became <productname>FreeTDS/JDBC</productname>.
+Brian Bruns, a Sybase DBA and originator of the <productname>FreeTDS</productname> project, had some <systemitem class="library">db-lib</systemitem> programs he wanted to run under Linux, and thus began the <productname>FreeTDS</productname> project. The original work focused on <systemitem class="library">db-lib</systemitem> and version 5.0 of the protocol, but quickly expanded to include a <systemitem class="library">ct-lib</systemitem> compatible layer and <acronym>TDS</> version 4.2.  Later support for <systemitem class="library">ODBC</systemitem> and <acronym>TDS 7.0 and 7.1</> was added. Craig Spannring wrote a Java  <acronym>JDBC</> driver which became <productname>FreeTDS/JDBC</productname>.
 			</para>
 			<para>
 As the project matured, it gained new participants.  Frediano Ziglio greatly expanded the <systemitem class="library">ODBC</systemitem> driver, and continues to improve both it and the underlying TDS library.  Bill Thompson wrote most of the present BCP system and added cursors to our <systemitem class="library">ct-lib</systemitem>.  Your humble author joined the project to add documentation, and wound up as the project's maintainer.  Such are the rewards for doing a good deed.  
@@ -392,7 +400,7 @@ There are a few optional arguments to <Command>configure</> that may be importan
 			<varlistentry>
 				<term><Option>--with-tdsver=<replaceable>VER</>
 					</Option></term>
-				<listitem><para>Specifies the default <acronym>TDS</> version.  (There are a couple of ways to set the <acronym>TDS</> version at run-time.  This parameter takes effect if no run-time settings are provided.) Acceptable values of <parameter>VER</> are <literal>4.2</literal>, <literal>4.6</literal>, <literal>5.0</literal>, <literal>7.0</literal>, and <literal>8.0</literal>.</para>
+				<listitem><para>Specifies the default <acronym>TDS</> version.  (There are a couple of ways to set the <acronym>TDS</> version at run-time.  This parameter takes effect if no run-time settings are provided.) Acceptable values of <parameter>VER</> are <literal>4.2</literal>, <literal>4.6</literal>, <literal>5.0</literal>, <literal>7.0</literal>, <literal>7.1</literal> and <literal>7.2</literal>.</para>
 					<para>The default is <literal>5.0</literal> if this argument is not passed to <Command>configure</Command>.</para>
 					</listitem>
 				</varlistentry>
@@ -569,7 +577,7 @@ url="http://www.madgoat.com">www.madgoat.com</ulink>).</para>
 		</sect3>
 		</sect2>
 		<sect2 id="osx"><title>OS X&reg;</title>
-  			<para>As of this writing ($Date: 2009/06/06 16:24:11 $), the regular distribution compiles on OS X.  Releases prior to 0.63 either did not compile or required patching.  </para>
+  			<para>As of this writing ($Date: 2009/08/25 14:25:35 $), the regular distribution compiles on OS X.  Releases prior to 0.63 either did not compile or required patching.  </para>
 
 		<sect3 id="OSX.Build.Update">
 			<title>Alternative build procedure</title>
@@ -703,8 +711,8 @@ The <acronym>TDS</> protocol version is probably something you'd rather not know
 	</row>
 	<row>
 	<entry>Microsoft SQL Server 2000</entry>
-	<entry>8.0</entry>
-	<entry>Include support for <symbol>bigint</> (64 bit integers), <symbol>variant</> and collation on all fields. <symbol>variant</> is not supported; collation is not widely used. </entry>
+	<entry>7.1</entry>
+	<entry>Include support for <symbol>bigint</> (64 bit integers), <symbol>variant</> and collation on all fields. Collation is not widely used. </entry>
 	</row>
 </tbody>	
 </tgroup>
@@ -801,11 +809,11 @@ The <filename>freetds.conf</filename> file is composed of two types of sections:
 [myserver3]
 	host = instancebox.mydomain.com
 	instance = foo
-	tds version = 8.0
+	tds version = 7.1
 </programlisting>
 </example>
 	<para>
-In this example, the default  <acronym>TDS</> version for all dataservers is set to <literal>4.2</>.  It is then overridden for <literal>myserver2</literal> (a Sybase server) which uses <literal>5.0</literal>, and <literal>myserver3</literal> (a MSSQL 2000 server) which uses <literal>8.0</literal>.
+In this example, the default  <acronym>TDS</> version for all dataservers is set to <literal>4.2</>.  It is then overridden for <literal>myserver2</literal> (a Sybase server) which uses <literal>5.0</literal>, and <literal>myserver3</literal> (a MSSQL 2000 server) which uses <literal>7.1</literal>.
 	</para>
 	<para>
 Usually, it is sufficient to state just the server's hostname and TDS protocol version.  Everything else can be inferred, unless your setup (or your server's) strays from the defaults.  
@@ -832,7 +840,7 @@ It bears mentioning here that prior versions of <productname>FreeTDS</productnam
 		Overridden by <link  linkend="TDSVER">TDSVER</link>.  
 		</entry> 
 	<entry>The <acronym>TDS</> protocol version to use when connecting.</entry>
-	<entry>4.2, 5.0, 7.0, 8.0</entry>
+	<entry>4.2, 5.0, 7.0, 7.1, 7.2</entry>
 	</row>
 	<row>
 	<entry>host</entry>
@@ -929,13 +937,13 @@ It bears mentioning here that prior versions of <productname>FreeTDS</productnam
 	<entry>emulate little endian</entry>
 	<entry>yes/no</entry>
 	<entry>no</entry>
-	<entry>Forces big endian machines (Sparc, PPC, PARISC) to act as little endian to communicate with MS Servers. Set automatically for <acronym>TDS</> 7.0/8.0 on big endian hosts</entry>
+	<entry>Forces big endian machines (Sparc, PPC, PARISC) to act as little endian to communicate with MS Servers. Set automatically for <acronym>TDS</> 7.0 or above on big endian hosts</entry>
 	</row>
 	<row>
 	<entry id="clientcharset">client charset</entry>
 	<entry>any valid iconv character set</entry>
 	<entry>ISO-8859-1<footnote><para>Valid for ISO 8859-1 character set.  See <link linkend="Localization">Localization and <acronym>TDS</> 7.0</link> for more information.  </para></footnote></entry>
-	<entry>Makes <productname>FreeTDS</productname> use iconv to convert to and from the specified character set from UCS-2 in <acronym>TDS</> 7.0/8.0.
+	<entry>Makes <productname>FreeTDS</productname> use iconv to convert to and from the specified character set from UCS-2 in <acronym>TDS</> 7.0 or above.
 As of 0.62 FreeTDS uses iconv to convert all character data, so there's no need to match the server's charset to insert any characters the server supports.</entry>
 	</row>
 	<row>
@@ -1155,7 +1163,7 @@ In a typical system, no environment variables need be used.  They're sometimes h
 	<varlistentry>
 		<term id="TDSPORT"><envar>TDSPORT</envar></term>
 		<listitem>
-			<para>specifies a TCP port number at which the dataserver is listening.  It overrides the default port (1433 for TDS 4.2/7.0/8.0, 4000 for TDS 5.0) as well as any port specified in the <filename>freetds.conf</filename> file.</para>
+			<para>specifies a TCP port number at which the dataserver is listening.  It overrides the default port (1433 for TDS 4.2/7.0/7.1/7.2, 4000 for TDS 5.0) as well as any port specified in the <filename>freetds.conf</filename> file.</para>
 		</listitem>
 	</varlistentry>	
 	<varlistentry>
@@ -1785,7 +1793,7 @@ found this section:
         [machine]
                 host = machine.example.com
                 port = 2500
-                tds version = 8.0
+                tds version = 7.1
 
 machine.example.com has address 10.82.32.177
 
@@ -1829,8 +1837,8 @@ Several version of Microsoft SQL server have a bug that affects big endian clien
 <Note><para>The terms <emphasis>big endian</emphasis> and <emphasis>little endian</emphasis> come originally from Gulliver's Travels.  In computer science they refer to the the integer byte-order for a processor.  Big endian processors, such as Sparc and PowerPC store the most significant byte in the first memory location of a multi-byte integer.  Little endian processors, such as Intel and Alpha do it the other way around.  So the 16-bit number 258 would be 0x0102 on big endian and 0x0201 on little endian machines.</para></Note>
 
 <para>
-In this example we want to force connections to a server named <literal>mssql</literal> to emulate a little endian client.  We are using protocol version 4.2 here, version 7.0 and 8.0 will automatically emulate little endian mode regardless of the <filename>freetds.conf</filename> setting.
-<emphasis>You shouldn't use this option, set another protocol version instead (7.0 or 8.0)</emphasis>.
+In this example we want to force connections to a server named <literal>mssql</literal> to emulate a little endian client.  We are using protocol version 4.2 here, version 7.0 or above will automatically emulate little endian mode regardless of the <filename>freetds.conf</filename> setting.
+<emphasis>You shouldn't use this option, set another protocol version instead (7.0, 7.1 or 7.2)</emphasis>.
 </para>
 <example id="e.g.LittleEndian">
 <title>Emulate Little Endian <filename>freetds.conf</filename> setting</title>
@@ -1932,7 +1940,7 @@ Why this happens is anyone's guess.  Here's one: it makes the datatype of the co
 		</sect1>
 		<sect1 id="domains">
 			<title>Domain Logins</title>
-<Note><para>Domain logins can be used only with TDS protocol versions 7.0 and 8.0.</para></Note>
+<Note><para>Domain logins can be used only with TDS protocol versions 7.0 or above.</para></Note>
 			<para>
 As mentioned in the installation chapter, <productname>Microsoft SQL Server</productname> includes the ability to use domain logins instead of standard server logins.  The advantage of doing this is that the passwords are encrypted on the wire using a challenge-response protocol.
 <productname>FreeTDS</productname> began supporting domain logins in version 0.60.
@@ -4239,7 +4247,7 @@ While UTF-8 solves many technical problems, it doesn't magically transform every
 		</section>
 		<section id="UnicodeFreeTDS"><title>Unicode and FreeTDS</title>
 			<para>
-Microsoft servers using TDS 7.0 and above (anything since SQL Server 6.5) transmit their data in UCS-2 format (16-bit integers).  Because most applications linked to <productname>FreeTDS</productname> are not prepared to deal with UCS-2 data, <productname>FreeTDS</productname> can convert the data to something more acceptable, including <acronym>ASCII</>.  To do so, it employs an  <productname>iconv</productname>  library.  <productname>FreeTDS</productname> determines the server's encoding from the TDS protocol and information reported by the server (generally per connection, but in the case of TDS 8.0, per result set column).  It discovers the client's encoding in <filename>freetds.conf</filename>.  <productname>FreeTDS</productname> will happily convert and convey your data in any <emphasis>single-byte</emphasis> format that <productname>iconv</productname> can provide.  In practice, this normally means some form of ISO 8859-x or UTF-8.  
+Microsoft servers using TDS 7.0 and above (anything since SQL Server 6.5) transmit their data in UCS-2 format (16-bit integers).  Because most applications linked to <productname>FreeTDS</productname> are not prepared to deal with UCS-2 data, <productname>FreeTDS</productname> can convert the data to something more acceptable, including <acronym>ASCII</>.  To do so, it employs an  <productname>iconv</productname>  library.  <productname>FreeTDS</productname> determines the server's encoding from the TDS protocol and information reported by the server (generally per connection, but in the case of TDS 7.1, per result set column).  It discovers the client's encoding in <filename>freetds.conf</filename>.  <productname>FreeTDS</productname> will happily convert and convey your data in any <emphasis>single-byte</emphasis> format that <productname>iconv</productname> can provide.  In practice, this normally means some form of ISO 8859-x or UTF-8.
 			</para>
 			<para>
 At some future time, <productname>FreeTDS</productname> aims to support Unicode and other multi-byte character sets.  It does not do so at the current time.  
diff --git a/include/sybdb.h b/include/sybdb.h
index d642612..8f0cb20 100644
--- a/include/sybdb.h
+++ b/include/sybdb.h
@@ -41,7 +41,7 @@ extern "C"
 #define TDS_STATIC_CAST(type, a) ((type)(a))
 #endif
 
-static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.90 2009/04/18 19:35:38 jklowden Exp $";
+static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.91 2009/08/25 14:25:35 freddy77 Exp $";
 static const void *const no_unused_sybdb_h_warn[] = { rcsid_sybdb_h, no_unused_sybdb_h_warn };
 
 #ifdef FALSE
@@ -73,7 +73,9 @@ static const void *const no_unused_sybdb_h_warn[] = { rcsid_sybdb_h, no_unused_s
 #define DBVERSION_100     2
 #define DBVERSION_42      3
 #define DBVERSION_70      4
-#define DBVERSION_80      5
+#define DBVERSION_71      5
+#define DBVERSION_80      DBVERSION_71
+#define DBVERSION_72      6
 
 /* these two are defined by Microsoft for dbsetlversion() */
 #define DBVER42 	  DBVERSION_42
@@ -94,6 +96,8 @@ static const void *const no_unused_sybdb_h_warn[] = { rcsid_sybdb_h, no_unused_s
 #define DBTDS_7_0               8	/* Microsoft SQL Server 7.0 */
 #define DBTDS_8_0               9	/* Microsoft SQL Server 2000 */
 #define DBTDS_9_0               10	/* Microsoft SQL Server 2005 */
+#define DBTDS_7_1               9	/* Microsoft SQL Server 2000 */
+#define DBTDS_7_2               10	/* Microsoft SQL Server 2005 */
 
 #define DBTXPLEN 16
 
diff --git a/include/tds.h b/include/tds.h
index 744ae2e..12278b8 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.320 2009/08/21 10:11:19 freddy77 Exp $ */
+/* $Id: tds.h,v 1.321 2009/08/25 14:25:35 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -776,24 +776,22 @@ typedef enum tds_encryption_level {
 #define TDS_DEF_CHARSET		"iso_1"
 #define TDS_DEF_LANG		"us_english"
 #if TDS42
-#define TDS_DEF_MAJOR		4
-#define TDS_DEF_MINOR		2
+#define TDS_DEFAULT_VERSION	0x402
 #define TDS_DEF_PORT		1433
 #elif TDS46
-#define TDS_DEF_MAJOR		4
-#define TDS_DEF_MINOR		6
+#define TDS_DEFAULT_VERSION	0x406
 #define TDS_DEF_PORT		4000
 #elif TDS70
-#define TDS_DEF_MAJOR		7
-#define TDS_DEF_MINOR		0
+#define TDS_DEFAULT_VERSION	0x700
 #define TDS_DEF_PORT		1433
-#elif TDS80
-#define TDS_DEF_MAJOR		8
-#define TDS_DEF_MINOR		0
+#elif TDS71
+#define TDS_DEFAULT_VERSION	0x701
+#define TDS_DEF_PORT		1433
+#elif TDS72
+#define TDS_DEFAULT_VERSION	0x702
 #define TDS_DEF_PORT		1433
 #else
-#define TDS_DEF_MAJOR		5
-#define TDS_DEF_MINOR		0
+#define TDS_DEFAULT_VERSION	0x500
 #define TDS_DEF_PORT		4000
 #endif
 
@@ -842,8 +840,7 @@ typedef struct tds_login
 	DSTR server_name;
 	DSTR server_addr;
 	int port;
-	TDS_TINYINT major_version;	/* TDS version */
-	TDS_TINYINT minor_version;	/* TDS version */
+	TDS_USMALLINT tds_version;	/* TDS version */
 	int block_size;
 	DSTR language;			/* e.g. us-english */
 	DSTR server_charset;		/* e.g. iso_1 */
@@ -868,8 +865,7 @@ typedef struct tds_connection
 	/* first part of structure is the same of login one */
 	DSTR server_name; /**< server name (in freetds.conf) */
 	int port;	   /**< port of database service */
-	TDS_TINYINT major_version;
-	TDS_TINYINT minor_version;
+	TDS_USMALLINT tds_version;
 	int block_size;
 	DSTR language;
 	DSTR server_charset;	/**< charset of server */
@@ -1314,8 +1310,7 @@ struct tds_socket
 {
 	TDS_SYS_SOCKET s;		/**< tcp socket, INVALID_SOCKET if not connected */
 	int oserr;
-	TDS_SMALLINT major_version;
-	TDS_SMALLINT minor_version;
+	TDS_USMALLINT tds_version;
 	TDS_UINT product_version;	/**< version of product (Sybase/MS and full version) */
 	char *product_name;
 
@@ -1417,7 +1412,7 @@ int tds_read_conf_file(TDSCONNECTION * connection, const char *server);
 void tds_parse_conf_section(const char *option, const char *value, void *param);
 TDSCONNECTION *tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale);
 void tds_fix_connection(TDSCONNECTION * connection);
-unsigned char tds_config_verstr(const char *tdsver, TDSCONNECTION * connection);
+TDS_USMALLINT tds_config_verstr(const char *tdsver, TDSCONNECTION * connection);
 void tds_lookup_host(const char *servername, char *ip);
 int tds_set_interfaces_file_loc(const char *interfloc);
 extern const char STD_DATETIME_FMT[];
@@ -1647,15 +1642,18 @@ int tds_writetext_continue(TDSSOCKET *tds, const TDS_UCHAR *text, TDS_UINT size)
 int tds_writetext_end(TDSSOCKET *tds);
 
 
-#define IS_TDS42(x) (x->major_version==4 && x->minor_version==2)
-#define IS_TDS46(x) (x->major_version==4 && x->minor_version==6)
-#define IS_TDS50(x) (x->major_version==5 && x->minor_version==0)
-#define IS_TDS70(x) (x->major_version==7 && x->minor_version==0)
-#define IS_TDS80(x) (x->major_version==8 && x->minor_version==0)
-#define IS_TDS90(x) (x->major_version==9 && x->minor_version==0)
+#define IS_TDS42(x) (x->tds_version==0x402)
+#define IS_TDS46(x) (x->tds_version==0x406)
+#define IS_TDS50(x) (x->tds_version==0x500)
+#define IS_TDS70(x) (x->tds_version==0x700)
+#define IS_TDS71(x) (x->tds_version==0x701)
+#define IS_TDS72(x) (x->tds_version==0x702)
+
+#define IS_TDS7_PLUS(x) ((x)->tds_version>=0x700)
+#define IS_TDS71_PLUS(x) ((x)->tds_version>=0x701)
 
-#define IS_TDS7_PLUS(x) ((x)->major_version>=7)
-#define IS_TDS8_PLUS(x) ((x)->major_version>=8)
+#define TDS_MAJOR(x) ((x)->tds_version >> 8)
+#define TDS_MINOR(x) ((x)->tds_version & 0xff)
 
 #define IS_TDSDEAD(x) (((x) == NULL) || TDS_IS_SOCKET_INVALID((x)->s))
 
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index d23172e..0c03301 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -61,7 +61,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.187 2009/07/10 18:03:52 jklowden Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.188 2009/08/25 14:25:35 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -183,7 +183,7 @@ bcp_init(DBPROCESS * dbproc, const char *tblname, const char *hfile, const char
 	/* 
 	 * Validate other parameters 
 	 */
-	if (dbproc->tds_socket->major_version < 5) {
+	if (dbproc->tds_socket->tds_version < 0x500) {
 		dbperror(dbproc, SYBETDSVER, 0);
 		return (FAIL);
 	}
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index b3e8270..f80892b 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.351 2009/08/19 09:50:37 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.352 2009/08/25 14:25:35 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -222,8 +222,11 @@ DBVERSION_46;
 #ifdef TDS70
 DBVERSION_70;
 #endif
-#ifdef TDS80
-DBVERSION_80;
+#ifdef TDS71
+DBVERSION_71;
+#endif
+#ifdef TDS72
+DBVERSION_72;
 #endif
 
 
@@ -890,12 +893,10 @@ dbsetlversion (LOGINREC * login, BYTE version)
 		
 	switch (version) {
 	case DBVER42:
-		login->tds_login->major_version = 4;
-		login->tds_login->minor_version = 2;
+		login->tds_login->tds_version = 0x402;
 		return SUCCEED;
 	case DBVER60:
-		login->tds_login->major_version = 6;
-		login->tds_login->minor_version = 0;
+		login->tds_login->tds_version = 0x600;
 		return SUCCEED;
 	}
 	
@@ -6505,24 +6506,19 @@ dbtds(DBPROCESS * dbproc)
 	CHECK_PARAMETER(dbproc, SYBENULL, -1);
 
 	if (dbproc->tds_socket) {
-		switch (dbproc->tds_socket->major_version) {
-		case 4:
-			switch (dbproc->tds_socket->minor_version) {
-			case 2:
-				return DBTDS_4_2;
-			case 6:
-				return DBTDS_4_6;
-			default:
-				return DBTDS_UNKNOWN;
-			}
-		case 5:
+		switch (dbproc->tds_socket->tds_version) {
+		case 0x402:
+			return DBTDS_4_2;
+		case 0x406:
+			return DBTDS_4_6;
+		case 0x500:
 			return DBTDS_5_0;
-		case 7:
+		case 0x700:
 			return DBTDS_7_0;
-		case 8:
-			return DBTDS_8_0;
-		case 9:
-			return DBTDS_9_0;
+		case 0x701:
+			return DBTDS_7_1;
+		case 0x702:
+			return DBTDS_7_2;
 		default:
 			return DBTDS_UNKNOWN;
 		}
diff --git a/src/dblib/unittests/t0022.c b/src/dblib/unittests/t0022.c
index 89f823d..bf2912c 100644
--- a/src/dblib/unittests/t0022.c
+++ b/src/dblib/unittests/t0022.c
@@ -6,7 +6,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: t0022.c,v 1.28 2009/07/21 06:40:16 freddy77 Exp $";
+static char software_version[] = "$Id: t0022.c,v 1.29 2009/08/25 14:25:35 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -104,11 +104,11 @@ main(int argc, char **argv)
 
 	add_bread_crumb();
 
-#if defined(DBTDS_7_0) && defined(DBTDS_8_0) && defined(DBTDS_9_0)
+#if defined(DBTDS_7_0) && defined(DBTDS_7_1) && defined(DBTDS_7_2)
 	if ((dbnumrets(dbproc) == 0)
 	    && ((DBTDS(dbproc) == DBTDS_7_0)
-		|| (DBTDS(dbproc) == DBTDS_8_0)
-		|| (DBTDS(dbproc) == DBTDS_9_0))) {
+		|| (DBTDS(dbproc) == DBTDS_7_1)
+		|| (DBTDS(dbproc) == DBTDS_7_2))) {
 		fprintf(stdout, "WARNING:  Received no return parameters from server!\n");
 		fprintf(stdout, "WARNING:  This is likely due to a bug in Microsoft\n");
 		fprintf(stdout, "WARNING:  SQL Server 7.0 SP3 and later.\n");
diff --git a/src/pool/util.c b/src/pool/util.c
index 1977f6d..7bb6610 100644
--- a/src/pool/util.c
+++ b/src/pool/util.c
@@ -33,7 +33,7 @@
 #include "pool.h"
 #include "tdsstring.h"
 
-static char software_version[] = "$Id: util.c,v 1.13 2006/12/26 14:56:20 freddy77 Exp $";
+static char software_version[] = "$Id: util.c,v 1.14 2009/08/25 14:25:35 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 void
@@ -73,7 +73,7 @@ dump_login(TDSLOGIN * login)
 	fprintf(stderr, "pass %s\n", tds_dstr_cstr(&login->password));
 	fprintf(stderr, "app  %s\n", tds_dstr_cstr(&login->app_name));
 	fprintf(stderr, "srvr %s\n", tds_dstr_cstr(&login->server_name));
-	fprintf(stderr, "vers %d.%d\n", login->major_version, login->minor_version);
+	fprintf(stderr, "vers %d.%d\n", TDS_MAJOR(login), TDS_MINOR(login));
 	fprintf(stderr, "lib  %s\n", tds_dstr_cstr(&login->library));
 	fprintf(stderr, "lang %s\n", tds_dstr_cstr(&login->language));
 	fprintf(stderr, "char %s\n", tds_dstr_cstr(&login->server_charset));
diff --git a/src/server/login.c b/src/server/login.c
index db0163d..c240162 100644
--- a/src/server/login.c
+++ b/src/server/login.c
@@ -58,7 +58,7 @@
 #include "tdssrv.h"
 #include "tdsstring.h"
 
-static char software_version[] = "$Id: login.c,v 1.54 2009/02/27 10:11:43 freddy77 Exp $";
+static char software_version[] = "$Id: login.c,v 1.55 2009/08/25 14:25:35 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 unsigned char *
@@ -122,6 +122,7 @@ void
 tds_read_login(TDSSOCKET * tds, TDSLOGIN * login)
 {
 	DSTR blockstr;
+	TDS_USMALLINT major;
 
 /*
 	while (len = tds_read_packet(tds)) {
@@ -138,8 +139,8 @@ tds_read_login(TDSSOCKET * tds, TDSLOGIN * login)
 	tds_read_string(tds, &login->app_name, 30);
 	tds_read_string(tds, &login->server_name, 30);
 	tds_get_n(tds, NULL, 256);	/* secondary passwd...encryption? */
-	login->major_version = tds_get_byte(tds);
-	login->minor_version = tds_get_byte(tds);
+	major = tds_get_byte(tds);
+	login->tds_version = (major << 8) | tds_get_byte(tds);
 	tds_get_smallint(tds);	/* unused part of protocol field */
 	tds_read_string(tds, &login->library, 10);
 	tds_get_byte(tds);	/* program version, junk it */
@@ -183,8 +184,7 @@ tds7_read_login(TDSSOCKET * tds, TDSLOGIN * login)
 	a = tds_get_int(tds);	/*total packet size */
 	a = tds_get_int(tds);	/*TDS version */
 	a &= 0xff;
-	login->major_version = a >> 4;
-	login->minor_version = a << 4;
+	login->tds_version = ((a << 4) & 0xff00) | (a & 0xf);
 	a = tds_get_int(tds);	/*desired packet size being requested by client */
 	tds_get_n(tds, NULL, 24);	/*magic1 */
 	a = tds_get_smallint(tds);	/*current position */
@@ -297,8 +297,7 @@ tds_alloc_read_login(TDSSOCKET * tds)
 	/* Use the packet type to determine which login format to expect */
 	switch (tds->in_flag) {
 	case 0x02: /* TDS4/5 login */
-		tds->major_version = 4;
-		tds->minor_version = 2;
+		tds->tds_version = 0x402;
 		tds_read_login(tds, login);
 		if (login->block_size == 0) {
 			login->block_size = 512;
@@ -306,14 +305,12 @@ tds_alloc_read_login(TDSSOCKET * tds)
 		break;
 
 	case 0x10: /* TDS7+ login */
-		tds->major_version = 7;
-		tds->minor_version = 0;
+		tds->tds_version = 0x700;
 		tds7_read_login(tds, login);
 		break;
 
 	case 0x12: /* TDS8+ prelogin, hopefully followed by a login */
-		tds->major_version = 8;
-		tds->minor_version = 0;
+		tds->tds_version = 0x701;
 		/* ignore client and just send our reply TODO... finish */
 		tds8_send_prelogin(tds);
 		tds_flush_packet(tds);
diff --git a/src/server/server.c b/src/server/server.c
index 673b36f..13ba955 100644
--- a/src/server/server.c
+++ b/src/server/server.c
@@ -30,7 +30,7 @@
 #include "tds.h"
 #include "tdssrv.h"
 
-static char software_version[] = "$Id: server.c,v 1.25 2008/05/28 21:08:33 freddy77 Exp $";
+static char software_version[] = "$Id: server.c,v 1.26 2009/08/25 14:25:35 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 void
@@ -166,8 +166,8 @@ tds_send_login_ack(TDSSOCKET * tds, const char *progname)
 		tds_put_byte(tds, 0);
 	} else {
 		tds_put_byte(tds, 1);
-		tds_put_byte(tds, tds->major_version);
-		tds_put_byte(tds, tds->minor_version);
+		tds_put_byte(tds, TDS_MAJOR(tds));
+		tds_put_byte(tds, TDS_MINOR(tds));
 	}
 	tds_put_byte(tds, 0);	/* unknown */
 	tds_put_byte(tds, 0);	/* unknown */
@@ -230,7 +230,7 @@ tds_send_done(TDSSOCKET * tds, int token, TDS_SMALLINT flags, TDS_INT numrows)
 	tds_put_byte(tds, token);
 	tds_put_smallint(tds, flags);
 	tds_put_smallint(tds, 2); /* are these two bytes the transaction status? */
-	if (IS_TDS90(tds))
+	if (IS_TDS72(tds))
 		tds_put_int8(tds, numrows);
 	else
 		tds_put_int(tds, numrows);
@@ -399,7 +399,7 @@ tds7_send_result(TDSSOCKET * tds, TDSRESULTINFO * resinfo)
  */
 void tds_send_table_header(TDSSOCKET * tds, TDSRESULTINFO * resinfo)
 {
-	switch (tds->major_version) {
+	switch (TDS_MAJOR(tds)) {
 	case 4:
 		/*
 		 * TDS4 uses TDS_COLNAME_TOKEN to send column names, and
@@ -416,8 +416,6 @@ void tds_send_table_header(TDSSOCKET * tds, TDSRESULTINFO * resinfo)
 		break;
 
 	case 7:
-	case 8:
-	case 9:
 		/*
 		 * TDS7+ uses a TDS7_RESULT_TOKEN to send all column
 		 * information.
diff --git a/src/server/unittest.c b/src/server/unittest.c
index 970c2f2..e1595fc 100644
--- a/src/server/unittest.c
+++ b/src/server/unittest.c
@@ -44,7 +44,7 @@
 #define sleep(s) Sleep((s)*1000)
 #endif
 
-static char software_version[] = "$Id: unittest.c,v 1.18 2008/01/07 14:07:21 freddy77 Exp $";
+static char software_version[] = "$Id: unittest.c,v 1.19 2009/08/25 14:25:35 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void dump_login(TDSLOGIN * login);
@@ -126,7 +126,7 @@ dump_login(TDSLOGIN * login)
 	printf("pass %s\n", tds_dstr_cstr(&login->password));
 	printf("app  %s\n", tds_dstr_cstr(&login->app_name));
 	printf("srvr %s\n", tds_dstr_cstr(&login->server_name));
-	printf("vers %d.%d\n", login->major_version, login->minor_version);
+	printf("vers %d.%d\n", TDS_MAJOR(login), TDS_MINOR(login));
 	printf("lib  %s\n", tds_dstr_cstr(&login->library));
 	printf("lang %s\n", tds_dstr_cstr(&login->language));
 	printf("char %s\n", tds_dstr_cstr(&login->server_charset));
